# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class EdgeOfflineConfiguration(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        EdgeOfflineConfiguration - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'pairing_id': 'str',
            'network': 'EdgeOfflineConfigurationNetwork'
        }

        self.attribute_map = {
            'pairing_id': 'pairingId',
            'network': 'network'
        }

        self._pairing_id = None
        self._network = None

    @property
    def pairing_id(self):
        """
        Gets the pairing_id of this EdgeOfflineConfiguration.
        The pairingId for your hardware Edge in the format: 00000-00000-00000-00000-00000.

        :return: The pairing_id of this EdgeOfflineConfiguration.
        :rtype: str
        """
        return self._pairing_id

    @pairing_id.setter
    def pairing_id(self, pairing_id):
        """
        Sets the pairing_id of this EdgeOfflineConfiguration.
        The pairingId for your hardware Edge in the format: 00000-00000-00000-00000-00000.

        :param pairing_id: The pairing_id of this EdgeOfflineConfiguration.
        :type: str
        """
        
        self._pairing_id = pairing_id

    @property
    def network(self):
        """
        Gets the network of this EdgeOfflineConfiguration.
        Network settings for your hardware Edge.

        :return: The network of this EdgeOfflineConfiguration.
        :rtype: EdgeOfflineConfigurationNetwork
        """
        return self._network

    @network.setter
    def network(self, network):
        """
        Sets the network of this EdgeOfflineConfiguration.
        Network settings for your hardware Edge.

        :param network: The network of this EdgeOfflineConfiguration.
        :type: EdgeOfflineConfigurationNetwork
        """
        
        self._network = network

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

